/*
 * TulipChain is the dmoz browser.	http://ostermiller.org/tulipchain/
 * Copyright (C) 2002 Stephen Ostermiller
 * http://ostermiller.org/contact.pl?regarding=TulipChain
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * See COPYING.TXT for details.
 */

 package com.Ostermiller.TulipChain;

import java.io.*;
import java.util.*;
import java.net.*;
import com.Ostermiller.util.*;
import java.text.*;

public class DmozMoveNote {

	String from;
	boolean unrevFrom = false;
	String to;
	boolean unrevTo= false;

	public DmozMoveNote(String s) throws IOException{
		int start = 12;
		int end = s.indexOf(" ", start);
		if (start > 0 && end > start && end <= s.length()){
			from = s.substring(start, end);
			if (end+8 <= s.length() && s.substring(end, end+8).equals(" (unrev)")){
				unrevFrom = true;
			}
			start = s.indexOf(" to ", end) + 4;
			end = s.indexOf(" ", start);
			if (end == -1) end = s.indexOf("]", start);
			if (end == -1) end = s.length();
			if (start > 0 && end > start && end <= s.length()){
				to = s.substring(start, end);
				if (end+8 <= s.length() && s.substring(end, end+8).equals(" (unrev)")){
					unrevTo = true;
				}
			} else {
				throw new IOException ("To category not found in " + s);
			}
		} else {
			throw new IOException ("From category not found in " + s);
		}
	}

	public String toString(){
		return "[Moved from " + from + (unrevFrom?" (unrev)":"") + " to " + to + (unrevTo?" (unrev)":"") + "]";
	}

	public static void main(String[] args) throws IOException{
		for (int i=0; i<args.length; i++){
			DmozMoveNote note = new DmozMoveNote(args[i]);
			System.out.println(note);
		}
	}
}