/*
 * TulipChain is the dmoz browser.  http://ostermiller.org/tulipchain/
 * Copyright (C) 2001 Stephen Ostermiller
 * http://ostermiller.org/contact.pl?regarding=TulipChain
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * See COPYING.TXT for details.
 */

package com.Ostermiller.TulipChain;

import java.net.*;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;

public class DmozTableModel extends AbstractTableModel {

	private DmozCat cat;
	final private String[] columnNames = {
		"URL",
		"Title",
		"Description",
	};

	public DmozTableModel(){
	}

	public String getColumnName(int col) {
		return columnNames[col];
	}

	public DmozTableModel(DmozCat cat){
		this.cat = cat;
	}

	public int getRowCount() {
		return cat.getListingCount();
	}

	public int getColumnCount() {
		return columnNames.length;
	}

	public void setCat(DmozCat cat){
		this.cat = cat;
		fireTableDataChanged();
	}

	public DmozCat getCat(){
		return cat;
	}

	public Object getValueAt(int row, int col) {
		switch (col){
			case 0:{
				return cat.getListing(row).getURLwStatus();
			} case 1:{
				return cat.getListing(row).getTitle();
			} case 2:{
				return cat.getListing(row).getDescription();
			} default:{
				return null;
			}
		}
	}

	public Class getColumnClass(int col) {
		try {
			switch (col){
				case 0:	{
					return Class.forName("com.Ostermiller.TulipChain.URLStatus");
				} case 1: case 2:{
					return Class.forName("java.lang.String");
				} default:{
					return null;
				}
			}
		} catch (ClassNotFoundException e){
			return null;
		}
	}

	public boolean isCellEditable(int row, int col) {
		return false;
	}

	public void setValueAt(Object value, int row, int col) {
	   switch (col){
			case 0:{
				cat.getListing(row).setURL((String)value);
			} case 1: {
				cat.getListing(row).setTitle((String)value);
			} case 2: {
				cat.getListing(row).setDescription((String)value);
			}
		}
		fireTableCellUpdated(row, col);
	}
}
