/*
 * EncodingLexer.java is a generated file.  You probably want to
 * edit EncodingLexer.lex to make changes.
 */

/*
 * TulipChain is the dmoz browser.	http://ostermiller.org/tulipchain/
 * Copyright (C) 2001-2002 Stephen Ostermiller
 * http://ostermiller.org/contact.pl?regarding=TulipChain
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * See COPYING.TXT for details.
 */

package com.Ostermiller.TulipChain;

import java.io.*;

%%

%public
%class EncodingLexer
%function next_token
%type String
%caseless


%{

    /**
     * Prints out tokens from a file or System.in.
     * If no arguments are given, System.in will be used for input.
     * If more arguments are given, the first argument will be used as
     * the name of the file to use as input
     *
     * @param args program arguments, of which the first is a filename
     */
    public static void main(String[] args) {
        InputStream in;
        try {
            if (args.length > 0){
                File f = new File(args[0]);
                if (f.exists()){
                    if (f.canRead()){
                        in = new FileInputStream(f);
                    } else {
                        throw new IOException("Could not open " + args[0]);
                    }
                } else {
                    throw new IOException("Could not find " + args[0]);
                }
            } else {
                in = System.in;
            }
            EncodingLexer shredder = new EncodingLexer(in);
            String t;
            while ((t = shredder.next_token()) != null) {
                System.out.println(t);
            }
        } catch (IOException e){
            System.out.println(e.getMessage());
        }
    }
%}

%unicode
%state CHARSET
%state DONE

AnyChar = ([A]|[^A])

%%


<YYINITIAL> ("<META"(~("charset="))) {
    yybegin(CHARSET);
}

<CHARSET> ([^\" ])* {
    yybegin(DONE);
    return yytext();
}

<DONE> {AnyChar} {
    return null;
}

<YYINITIAL> {AnyChar} {
}

