/*
 * TulipChain is the dmoz browser.  http://ostermiller.org/tulipchain/
 * Copyright (C) 2001-2002 Stephen Ostermiller
 * http://ostermiller.org/contact.pl?regarding=TulipChain
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * See COPYING.TXT for details.
 */

package com.Ostermiller.TulipChain;

import javax.swing.*;
import javax.swing.table.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.border.Border;
import java.net.*;
import java.io.*;

class TextRenderer extends JTextArea implements TableCellRenderer {
	Border unselectedBorder = null;
	Border selectedBorder = null;
	boolean isBordered = true;

	public TextRenderer(){
		this(true);
	}

	public TextRenderer(boolean isBordered){
		super();
		this.isBordered = isBordered;
		setEditable(false);
		setLineWrap(true);
		setWrapStyleWord(true);
		setFont(getFont().deriveFont(Font.PLAIN));

	}

	public Component getTableCellRendererComponent(JTable table, Object text,
		boolean isSelected, boolean hasFocus, int row, int column) {
		setText((String)text);
		/*if (column == 2){
			TulipChain.table.setRowHeight(row, getPreferredSize().height);
		}*/
		setToolTipText(null);
		if (isBordered) {
			if (isSelected) {
				if (selectedBorder == null) {
					selectedBorder = BorderFactory.createMatteBorder(1,2,1,2,
											  table.getSelectionBackground());
				}
				setBorder(selectedBorder);
			} else {
				if (unselectedBorder == null) {
					unselectedBorder = BorderFactory.createMatteBorder(1,2,1,2,
											  table.getBackground());
				}
				setBorder(unselectedBorder);
			}
		}
		return this;
	}
}
