#!/bin/bash

version=`grep "^latest=" update`
version=${version:7}
if [ -z "`grep $version TulipChain.java`" ]
then
    echo "Version numbers in update and TulipChain.java do not match."
    exit 1
fi
if [ -z "`grep $version TulipChain.class`" ]
then
    make
fi
if [ ! -e tulip.jar ]
then
    make build
fi

size=`ls -lah tulip.jar`
size=${size:38:4}
if [ -z "`grep -i $size index.html`" ]
then
    echo "tulip.jar size is $size but index.html does not show that."
    exit 1
fi

filename="tulip_${version/./_}.jar"
cp "tulip.jar" "$filename"
scp "tulip.jar" "$filename" "index.html" "update" deadsea@ostermiller.org:www/tulipchain
rm "$filename"
